/*
 * Copyright (c) 2022 Auxio Project
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
 
package org.oxycblt.auxio.music.extractor

/**
 * Represents the result of an extraction operation.
 * @author Alexander Capehart (OxygenCobalt)
 */
enum class ExtractionResult {
    /** A raw song was successfully extracted from the cache. */
    CACHED,

    /** A raw song was successfully extracted from parsing it's file. */
    PARSED,

    /** A raw song could not be parsed. */
    NONE
}
